#!./sowish -file
# 
# audioin.tcl
#
# basic tcl script to check audio input
# and scrolling display
#
# dpwe@media.mit.edu 1995jan31
#

# set up the display

frame  .buttons
button .buttons.quit    -text "quit" -command "quit"

waveform .w -buflen 200

pack .buttons         -side top -fill x -expand no -padx 6 -pady 6
pack .buttons.quit    -side left -expand no

pack .w -fill both -expand y

set srate 8000
audio au -samplerate $srate -chans 1 -format short

# endless loop

proc myupdate {} {
    global srate
    set nframes 150
    set ms [expr "int(0.8*1000.0*$nframes/$srate)"]
    set v [expr "8.686*log([au scan $nframes])"]
    set w [expr "($v+40.0)/40.0"]
    .w push $w
    update
    after $ms "myupdate"
}

myupdate
