#
# demostft.tcl
#
# Demonstrate the new STFT function
#
# 1996nov27 dpwe@icsi.berkeley.edu
# $Header: $

set libdir /u/dpwe/lib/sun4-sunos5
load $libdir/libtclsound.so
load $libdir/libgdtcl.so

set so [sound so]
set sf "2151-A-0002.aif"
$so open $sf

set fa [farray fa]
stftsound $so $fa 0 [$so cget -nframes] 128 32 64

# $fa size --> 65 [cols]

$fa transpose

# Show top 50 dB
$fa offset [expr 50.0-[$fa max]]
$fa norm

set size [$fa size]
set rows [lindex $size 0]
set cols [lindex $size 1]

set im [gd create $rows $cols]

set cmap ""
for {set i 0} {$i<20} {incr i} {lappend cmap [gd color new $im [expr $i*12] [expr $i*12] [expr $i*12]]}
gd arrayimage $im $cmap 0 0 $fa

set imgout "t2.gif"
set out [open $imgout w]
gd writeGIF $im $out
close $out
exec mv $imgout /u/dpwe/public_html
