//
// tclDpweMisc.cc
// 
// random tcl extension
// 
// dpwe@media.mit.edu 1994nov17
//

#include <assert.h>

#include <stdlib.h>	/* atoi() proto on solaris */

#include "Sound.h"
extern "C" {
#include "tcl.h"
int Misc_Init(Tcl_Interp *interp);
   /* add the tcl commands defined in this package to the interpreter */
}

#ifdef __sgi
#include <audio.h>

int audioStatusCommand(ClientData clientData, Tcl_Interp *interp, 
		 int argc, char **argv)
{	/* tcl command to read the audio status */
    char rslt[32];
    long pvb[32], pvl = 0;
    int inputSource, inputRate, outputRate, inputCount, outputCount;
    char *inpSrcName = "unknown";

    if(argc > 1) {
	Tcl_AppendResult(interp, "wrong # args; should be \"", 
			 argv[0], " which returns inSrc inRate outRate inCnt outCnt ", NULL);
	return TCL_ERROR;
    }
    pvb[pvl] = AL_INPUT_SOURCE;	pvl += 2;	/* 1 */
    pvb[pvl] = AL_INPUT_RATE;	pvl += 2;	/* 3 */
    pvb[pvl] = AL_OUTPUT_RATE;	pvl += 2;	/* 5 */
    pvb[pvl] = AL_INPUT_COUNT;	pvl += 2;	/* 7 */
    pvb[pvl] = AL_OUTPUT_COUNT;	pvl += 2;	/* 9 */
    ALgetparams(AL_DEFAULT_DEVICE, pvb, pvl);
    inputSource = pvb[1];
    inputRate   = pvb[3];
    outputRate  = pvb[5];
    inputCount  = pvb[7];
    outputCount = pvb[9];
    
    if(inputSource==AL_INPUT_LINE)	inpSrcName = "line";
    if(inputSource==AL_INPUT_MIC)	inpSrcName = "mic";
    if(inputSource==AL_INPUT_DIGITAL)	inpSrcName = "digital";

    sprintf(rslt, "%s %d %d %d %d", inpSrcName, inputRate, outputRate, inputCount, outputCount);

    interp->result = rslt;
    return TCL_OK;
}
#endif /* __sgi */

extern "C" {
#include <DATUtils.h>
};

int datinfoCommand(ClientData clientData, Tcl_Interp *interp, 
		   int argc, char **argv)
{	/* look at a dat file and return a vector of its status */
    if(argc != 2)  {
	Tcl_AppendResult(interp, "wrong # args; should be \"", 
			 argv[0], " datfilename\"", NULL);
	return TCL_ERROR;
    }
    int rc, dsets, chans, rows, cols;
    double sr;
    char fmt;
    rc = DATInfo(argv[1], &dsets, &chans, &rows, &cols, &sr, &fmt);
    if(rc)  {
	char s[80];
	sprintf(s, "%d %d %d %d %.1f %c", dsets, chans, rows, cols, sr, fmt);
	Tcl_AppendResult(interp, s, NULL);
    }
    return TCL_OK;
}

int Misc_Init(Tcl_Interp *interp)
{   /* add the tcl commands defined in this package to the interpreter */
#ifdef __sgi
    Tcl_CreateCommand(interp, "audiostatus", audioStatusCommand, 
		      (ClientData) NULL, (void (*)(ClientData)) NULL);
#endif /* __sgi */
    Tcl_CreateCommand(interp, "datinfo", datinfoCommand, (ClientData) NULL,
		      (void (*)(ClientData)) NULL);
    return TCL_OK;
}
