//
// tkRand.cc
//
// Add a random() function to the Tcl expression evaluator.
//
// dpwe@media.mit.edu 1996mar03
//

extern "C" {

#include <stdio.h>
#include <math.h>
#include <tcl.h>

#include <sys/types.h>
#include <time.h>	// for time(), for seed

#ifdef __sun
/* Need protos for random?? on Solaris 5.5 */
long random(void);
int srandom(unsigned seed);
#endif /* __SOLARIS */

int Rand_Init(Tcl_Interp* interp);

int rand_mathproc(ClientData clientData, Tcl_Interp* interp, 
		  Tcl_Value* args, Tcl_Value* resultPtr);

};

int rand_mathproc(ClientData clientData, Tcl_Interp* interp, 
		  Tcl_Value* args, Tcl_Value* resultPtr)
{   /* math proc to call rand(3c).  Pretty simple as no args */
    /* actually, use random() because it's better */
    resultPtr->intValue = random();
    resultPtr->type     = TCL_INT;
    return TCL_OK;
}

int Rand_Init(Tcl_Interp* interp) 
{   /* just register the 'rand' fn with the expr evaluator */
    ClientData clientData = 0;
    char* name = "random";
    int numArgs = 0;
    Tcl_ValueType* argTypes = 0;
    Tcl_MathProc* proc = rand_mathproc;

    Tcl_CreateMathFunc(interp, name, numArgs, argTypes, proc, clientData);

    // While we're here, seed the random number generator from the time
    srandom(time(0));

    return TCL_OK;
}
