/*
 * tclsoundInit.c
 * 
 * Init file for tclsound shared lib (tksound without graphics (Tk) stuf)
 * extensions to Tcl for handing sound and soundfiles
 *
 * 1996nov04 dpwe@icsi.berkeley.edu
 * $Header: $
 */

#include <tcl.h>

extern "C" {
extern int Farray_Init(Tcl_Interp *interp);
extern int Sound_Init(Tcl_Interp *interp);
extern int SoundStft_Init(Tcl_Interp *interp);
extern int Misc_Init(Tcl_Interp *interp);
extern int Audio_Init(Tcl_Interp *interp);
extern int Rand_Init(Tcl_Interp *interp);
};

/* My libraries want to resolve against this, so fake it in */
char *programName = "TclsoundPkg";

/* Initialization commands */
extern "C" int Tclsound_Init(Tcl_Interp *interp)
{   /* Package opening call */
    
    // for Tcl7.5+, signal the package mechanism
    Tcl_PkgProvide(interp, "Tclsound", "1.0");

    if(Farray_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Audio_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(Sound_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(SoundStft_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Misc_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(Rand_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }

    return TCL_OK;
}

extern "C" int Tclsound_SafeInit(Tcl_Interp *interp)
{   /* Package opening call */
    /* fprintf(stderr, "Tksound: cannot load under safe interpreter\n");
    return TCL_ERROR; */

    // for Tcl7.5+, signal the package mechanism
    Tcl_PkgProvide(interp, "Tclsound", "1.0");

    if(Farray_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Audio_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(Sound_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(SoundStft_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Misc_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(Rand_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }

    return TCL_OK;
}

