/*
 * tksoundInit.c
 * 
 * Init file for tksound shared lib
 * extensions to Tcl/Tk for handing sound and soundfiles
 *
 * 1996nov04 dpwe@icsi.berkeley.edu
 * $Header: $
 */

#include <tcl.h>

extern "C" {
extern int Farray_Init(Tcl_Interp *interp);
extern int Sound_Init(Tcl_Interp *interp);
extern int SoundStft_Init(Tcl_Interp *interp);
extern int SndWvfm_Init(Tcl_Interp *interp);
extern int Timeline_Init(Tcl_Interp *interp);
extern int Image_Init(Tcl_Interp *interp);
extern int ShmImage_Init(Tcl_Interp *interp);
extern int Misc_Init(Tcl_Interp *interp);
extern int MiscTk_Init(Tcl_Interp *interp);
extern int Waveform_Init(Tcl_Interp *interp);
extern int Audio_Init(Tcl_Interp *interp);
extern int Rand_Init(Tcl_Interp *interp);
};

/* Initialization commands */
extern "C" int Tksound_Init(Tcl_Interp *interp)
{   /* Package opening call */
    
    // for Tcl7.5+, signal the package mechanism
    Tcl_PkgProvide(interp, "Tksound", "1.0");

    if(Farray_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Audio_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(Waveform_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Sound_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(SoundStft_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(SndWvfm_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Timeline_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Image_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(ShmImage_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Misc_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(MiscTk_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Rand_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }

    return TCL_OK;
}

extern "C" int Tksound_SafeInit(Tcl_Interp *interp)
{   /* Package opening call */
    /* fprintf(stderr, "Tksound: cannot load under safe interpreter\n");
    return TCL_ERROR; */

    // for Tcl7.5+, signal the package mechanism
    Tcl_PkgProvide(interp, "Tksound", "1.0");

    if(Farray_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Audio_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(Waveform_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Sound_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(SoundStft_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(SndWvfm_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Timeline_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Image_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(ShmImage_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Misc_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }
    if(MiscTk_Init(interp) == TCL_ERROR)	{ return TCL_ERROR; }
    if(Rand_Init(interp) == TCL_ERROR)		{ return TCL_ERROR; }

    return TCL_OK;
}

